    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.axis;
    034
    035import java.util.EventObject;
    036
    037import org.jfree.chart3d.internal.Args;
    038
    039/**
    040 * An event associated with a change to an {@link Axis3D}.  These change
    041 * events will be generated by an axis and broadcast to the plot that owns the
    042 * axis (in the standard setup, the plot will then trigger its own change event
    043 * to notify the chart that a subcomponent of the plot has changed).
    044 * <br><br>
    045 * NOTE: This class is serializable, but the serialization format is subject
    046 * to change in future releases and should not be relied upon for persisting
    047 * instances of this class.
    048 */
    049@SuppressWarnings("serial")
    050public class Axis3DChangeEvent extends EventObject {
    051
    052    /** The axis associated with this event. */
    053    private Axis3D axis;
    054
    055    /**
    056     * A flag indicating whether or not the change requires the 3D world to
    057     * be updated.
    058     */
    059    private boolean requiresWorldUpdate;
    060
    061    /**
    062     * Creates a new event.
    063     *
    064     * @param axis  the axis ({@code null} not permitted).
    065     * @param requiresWorldUpdate  a flag indicating whether or not this change
    066     *     requires the 3D world to be updated.
    067     */
    068    public Axis3DChangeEvent(Axis3D axis, boolean requiresWorldUpdate) {
    069        this(axis, axis, requiresWorldUpdate);
    070    }
    071
    072    /**
    073     * Creates a new event.
    074     *
    075     * @param source  the event source.
    076     * @param axis  the axis ({@code null} not permitted).
    077     * @param requiresWorldUpdate  a flag indicating whether or not this change
    078     *     requires the 3D world to be updated.
    079     */
    080    public Axis3DChangeEvent(Object source, Axis3D axis,
    081            boolean requiresWorldUpdate) {
    082        super(source);
    083        Args.nullNotPermitted(axis, "axis");
    084        this.axis = axis;
    085        this.requiresWorldUpdate = requiresWorldUpdate;
    086    }
    087
    088    /**
    089     * Returns the axis associated with this event.
    090     *
    091     * @return The axis (never {@code null}).
    092     */
    093    public Axis3D getAxis() {
    094        return this.axis;
    095    }
    096
    097    /**
    098     * Returns the flag that indicates whether or not this change will require
    099     * the 3D world to be updated.
    100     *
    101     * @return A boolean.
    102     *
    103     * @since 1.2
    104     */
    105    public boolean requiresWorldUpdate() {
    106        return this.requiresWorldUpdate;
    107    }
    108}